(define (println . args)
  (for-each display args) (newline))
(define (printsln spacer . args)
  (for-each (lambda (x) (display x) (display spacer)) args) (newline))

(define (interface-add! . ifc)
  (serveez-interfaces (append! (serveez-interfaces) ifc)))

(define (loadpath-add! . path)
  (serveez-loadpath (append! (serveez-loadpath) path)))

(define (bind-servers! . args)
  (let ((server-list '())  ;; Initialize lists.
        (port-list '()))

    (for-each
     (lambda (elem)
       (cond ((serveez-port? elem)
	      (set! port-list (cons elem port-list)))
	     ((serveez-server? elem)
	      (set! server-list (cons elem server-list)))))
     args)

    (for-each
     (lambda (server)
       ;; ... for each server, iterate over port list and ...
       (for-each
	(lambda (port)
	  ;; ... bind each port to each server.
	  (bind-server! port server))
	port-list))
     server-list)))

(define (create-tcp-port! basename port)
  (let ((portname (string-append basename (number->string port))))
    (if (not (serveez-port? portname))
	(define-port! portname 
	  `((proto . tcp) 
	    (port . ,port))))
    portname))

(define (bind-tcp-port-range! from to . args)
  (do ((no from (+ no 1)))
      ((> no to))
    (for-each
     (lambda (server)
       (bind-server! (create-tcp-port! "guile-tcp-port-" no) server))
     args)))

(define (create-udp-port! basename port)
  (let ((portname (string-append basename (number->string port))))
    (if (not (serveez-port? portname))
	(define-port! portname 
	  `((proto . udp) 
	    (port . ,port))))
    portname))

(define (bind-udp-port-range! from to . args)
  (do ((no from (+ no 1)))
      ((> no to))
    (for-each
     (lambda (server)
       (bind-server! (create-udp-port! "guile-udp-port-" no) server))
     args)))

(define (getrpcent) (getrpc))
(define (getrpcbyname name) (getrpc name))
(define (getrpcbynumber number) (getrpc number))
(define (setrpcent . stayopen)
  (if (pair? stayopen)
      (setrpc (car stayopen))
      (setrpc #f)))
(define (endrpcent) (setrpc))
